#include <stdlib.h>
#include "mp4.h"

// export the RTL 'free' function for releasing buffers inside the DLL
void rtlFree ( void *Buf )
{
  free ( Buf ) ;
}

// these are wrappers around the 'duration' functions to avoid using
// int64 types since my borland release doesn't support this type...

void MP4GetTrackDurationEx ( MP4FileHandle hFile,
    MP4TrackId trackId, LARGE_INTEGER *Duration )
{
	MP4Duration Dur = MP4GetTrackDuration ( hFile, trackId ) ;

	Duration->QuadPart = Dur ;
}

void MP4ConvertFromTrackDurationEx (  
	MP4FileHandle hFile,
    MP4TrackId trackId,
    LARGE_INTEGER *duration,
    u_int32_t timeScale)
{
	u_int64_t Dur = MP4ConvertFromTrackDuration ( hFile, trackId, duration->QuadPart, timeScale ) ;

	duration->QuadPart = Dur ;
}

MP4SampleId MP4GetSampleIdFromMsTime (
    MP4FileHandle hFile,
    MP4TrackId trackId,
    uint32_t when,
    bool wantSyncSample )
{
	u_int64_t Duration ;

	Duration = MP4ConvertToTrackDuration ( hFile, trackId, when, MP4_MSECS_TIME_SCALE ) ;

	return MP4GetSampleIdFromTime ( hFile,
                                    trackId,
                                    Duration,
                                    wantSyncSample ) ;
}
